/*
Scrieti un program C care sa realizeze achizitii folosind ATMIO16E10, pe canalul 1, in mod diferential si pe canalul 3, in mod "single ended" cu referinta.Pe canalul 1 se vor citi tensiuni pozitive de ordinul 500mV, iar pe canalul 3 se vor citi tensiuni pozitive si negative de modul aproximativ 1V. Se doreste afisarea tuturor valorilor citite pe un grafic astfel: cu rosu tensiunile achizitionate pe canalul 1, cu verde tensiunile achizitionate pe canalul 3. Citirea se efectueaza cu o perioada de aproximativ 0.5 secunde pe canalul 1 si 8 secunde pe canalul 3. Graficul trebuie actualizat la fiecare valoare nou achizitionata (afisari pentru max 100 de esantioane).
*/

/*ce am dedus din enuntul problemei:
- achizitii multi canal asincrone cu rata diferita pe fiecare canal
- se folosesc SCAN_Sequence_Setup

*/

#include "nidaq.h"
#include "nidaqerr.h"
#include "nidaqcns.h"
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>

int handle;
int message,wParam;
unsigned long Iparam;
unsigned long seg, off;

int NUM;

#pragma option -N-
void _loadds far cadr(int *h, int *m, unsigned *wP, unsigned long *IP) {
	NUM++;//numara esantioanele
}

#pragma option -N

int main(void) {

	int err;
	unsigned *data;
	unsigned int buffer[100];//100 de esantioane
	unsigned long count = 100;

	int chanVector[2] = {1,3};
	int gainVector[2] = {20,5};
	int scanRateDivisorVector[2] = {1,16};
	/*
	Cam asa ar trebui sa fie (cred): 
	scan:    #1  #2  #3  #4  #5  #6  #7  #8  #9  #10 #11 #12 #13 #14 #15 #16 #17
	canal:	 1,3  1   1   1   1   1   1   1   1   1   1   1   1   1   1   1  1,3
	timp:	  |---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|
	(sec)	  0  0.5  1  1.5  2  2.5  3  3.5  4  4.5  5  5.5  6  6.5  7  7.5  8

	deci scan rate baza ar fi 2 scans/s (cred)
	*/
	int scansPerSequence = 16;
	int samplesPerSequence = 17;
	int timebase, sampleInterval;
	int scanSequenceVector[samplesPerSequence] = {1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

	clrscr();
	seg = FP_SEG(cadr);
	off = FP_OFF(cadr);
	seg = (seg<<16)+off;

	err = USE_E_Series();
	ErrPrint("USE_Eseries", err);

	//canal 1, mod diferenţial, operare unipolara
	AI_Configure(1, 1, 0, 0, 1, 0);

	//canal 3, mod cu referinta, operare bipolara
	AI_Configure(1, 3, 1, 0, 0, 0);

	handle = 2;
	message = 2;

	err = Config_DAQ_Event_Message(1,1,"AI1,AI3",1,1L,0L,0L,0L,handle,message,seg);
	ErrPrint("Config event", err);
	
	ancnum = 0;//variabila de urmarire NUM
	DAQ_Rate(2,0,&timebase,&sampleInterval);
	SCAN_Sequence_Setup(1,2,chanVector,gainVector,scanRateDivisorVector,&scansPerSequence,&samplesPerSequence);
	ErrPrint("Scan-setup",err);
	SCAN_Sequence_Retrieve(1,samplesPerSequence,scanSequenceVector);
	SCAN_Start(1,buffer,count,timebase,sampleInterval,5,1600);


	//initializare modul grafic	
	int gdriver = DETECT, gmode, errorcode;
	initgraph(&gdriver, &gmode, "");
	errorcode = graphresult();

	if (errorcode != grOk) {
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		exit(EXIT_FAILURE);
	}

	int ch = 1;//pe poz a 2-a din buffer se va afla valoarea citita de pe canalul 3, apoi pe poz 2+17, apoi 2+2·17, 2+3·17,..etc
	
	while (NUM < 100) {
		if (ancnum!=NUM) {
			ancnum++;
			if (ancnum == ch) 
				putpixel(ancnum,(buffer[ancnum]/2048)*(5/gainvector[1]),GREEN);
			else putpixel(ancnum,(buffer[ancnum]/4096)*(10/gainVector[0]),RED);
			ch+=16;
		}
	}
	
	err = DAR_Clear(1);
	ErrPrint("DAQ_Clear",err);
	closegraph();

	return 0;
}
